﻿using System;
using System.Diagnostics;
using System.Globalization;
using System.IO;
using System.Threading;
using System.Windows.Forms;
using System.Xml.Linq;

namespace DAMac {
    static class Program {
        [STAThread]
        static void Main() {
            if(Process.GetProcessesByName("AoEnchanter").Length == 2) return;
            AppDomain.CurrentDomain.UnhandledException += new UnhandledExceptionEventHandler(MyUnhandledEx);
            Application.ThreadException += new ThreadExceptionEventHandler(MyThreadingEx);

            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Application.Run(new DAMacForm());
        }

        //All Non-Main Thread Exception Types
        static void MyUnhandledEx(object sender, UnhandledExceptionEventArgs args) {
            using(StreamWriter sw = new StreamWriter("CrashLogUnhandledEx (AoEnchanter " + Application.ProductVersion + ")(DAD " + (File.Exists("DAData.xml") ? XElement.Load("DAData.xml").Element("Version").Value : "0.00") + ") " + DateTime.Now.ToString("u", CultureInfo.InvariantCulture).TrimEnd('Z').Replace(":", "-") + ".txt", true)) sw.WriteLine(((Exception)args.ExceptionObject).ToString());
            if(args.IsTerminating) Environment.Exit(0);
        }

        //Only the Main Thread Exception Handler
        static void MyThreadingEx(object sender, ThreadExceptionEventArgs args) {
            using(StreamWriter sw = new StreamWriter("CrashLogThreadingEx (AoEnchanter " + Application.ProductVersion + ")(DAD " + (File.Exists("DAData.xml") ? XElement.Load("DAData.xml").Element("Version").Value : "0.00") + ") " + DateTime.Now.ToString("u", CultureInfo.InvariantCulture).TrimEnd('Z').Replace(":", "-") + ".txt", true)) sw.WriteLine(args.Exception.ToString());
            Environment.Exit(0);
        }
    }
}