using System;
using System.Drawing;
using System.Threading;
using System.Windows.Forms;
using DAMacTypesLib;
using DATypesLib;
using MyToolTipLib;

namespace DAMac {
    public class DAMacros : DAMacCore {
        public DAMacForm MainF;

        public DAMacros(IntPtr mainHandle) : this(mainHandle, null, null, null) { }
        public DAMacros(IntPtr mainHandle, NotifyIcon sysTray, Icon sysNormal, Icon sysRun)
            : base(mainHandle, sysTray, sysNormal, sysRun) {

            //DAMac Base Hotkeys
            AddHotkey(Keys.Scroll, 0, Base_ExitDAMac, false);
            AddHotkey(Keys.Pause, 0, Base_StopAllMacros, false);
            AddHotkey(Keys.Pause, WindowModifiers.MOD_SHIFT, Base_ResetAllPointers, true);
        }

        ushort? currHotkeySet = null;
        public void changeMacro(int selectionIndex) {
            if(currHotkeySet.HasValue && selectionIndex >= 0 && selectionIndex <= 12) RemoveHotkey(currHotkeySet.Value);

            switch(selectionIndex) {
                case 0:
                    currHotkeySet = AddHotkey(Keys.Oemtilde, 0, aoenchanter, true);
                    break;
                case 1:
                    currHotkeySet = AddHotkey(Keys.Subtract, 0, aoenchanter, true);
                    break;
                case 2:
                    currHotkeySet = AddHotkey(Keys.D1, 0, aoenchanter, true);
                    break;
                case 3:
                    currHotkeySet = AddHotkey(Keys.F1, 0, aoenchanter, true);
                    break;
                case 4:
                    currHotkeySet = AddHotkey(Keys.F2, 0, aoenchanter, true);
                    break;
                case 5:
                    currHotkeySet = AddHotkey(Keys.F3, 0, aoenchanter, true);
                    break;
                case 6:
                    currHotkeySet = AddHotkey(Keys.F4, 0, aoenchanter, true);
                    break;
                case 7:
                    currHotkeySet = AddHotkey(Keys.F5, 0, aoenchanter, true);
                    break;
                case 8:
                    currHotkeySet = AddHotkey(Keys.F6, 0, aoenchanter, true);
                    break;
                case 9:
                    currHotkeySet = AddHotkey(Keys.F7, 0, aoenchanter, true);
                    break;
                case 10:
                    currHotkeySet = AddHotkey(Keys.F8, 0, aoenchanter, true);
                    break;
                case 11:
                    currHotkeySet = AddHotkey(Keys.F9, 0, aoenchanter, true);
                    break;
                case 12:
                    currHotkeySet = AddHotkey(Keys.F10, 0, aoenchanter, true);
                    break;
            }
        }

        //(ConstantAO)
        private void aoenchanter(MacInfo runInfo) {
            byte[] puin, dall, suain, ard, mor, cradh, beag, beagcradh;
            beag = GetDASlot(DAPane.d, "ao beag cradh", false, runInfo, DASlotSearchType.StartsWith);
            cradh = GetDASlot(DAPane.d, "ao cradh", false, runInfo, DASlotSearchType.StartsWith);
            mor = GetDASlot(DAPane.d, "ao mor cradh", false, runInfo, DASlotSearchType.StartsWith);
            ard = GetDASlot(DAPane.d, "ao ard cradh", false, runInfo, DASlotSearchType.StartsWith);
            suain = GetDASlot(DAPane.d, "ao suain", false, runInfo, DASlotSearchType.StartsWith);
            dall = GetDASlot(DAPane.d, "ao dall", false, runInfo, DASlotSearchType.StartsWith);
            puin = GetDASlot(DAPane.d, "ao puinsein", false, runInfo, DASlotSearchType.StartsWith);
            beagcradh = GetDASlot(DAPane.d, "beag cradh", false, runInfo, DASlotSearchType.StartsWith);

            if((beag.Length == 0 && MainF.checkBox_beag.Checked) || (cradh.Length == 0 && MainF.checkBox_cradh.Checked) || (mor.Length == 0 && MainF.checkBox_mor.Checked) || (ard.Length == 0 && MainF.checkBox_ard.Checked) || (suain.Length == 0 && MainF.checkBox_suain.Checked) || (dall.Length == 0 && MainF.checkBox_dall.Checked) || (puin.Length == 0 && MainF.checkBox_puin.Checked) || (beagcradh.Length == 0 && MainF.checkBox_beagcradh.Checked)) {
                MessageBox.Show("Can't find one of the spells that you have enabled... Make sure you have them all");
                HKRunning[runInfo] = false;
                return;
            }

            MyToolTip Tip = new MyToolTip();
            if(MainF.checkBox_tooltip.Checked) Tip.ShowToolTip("Ao'enchanter Enabled", runInfo.Handle);

            DASpell[] spellsToCheck = new DASpell[] { DASpell.DarkSeal, DASpell.ArdCradh, DASpell.MorCradh, DASpell.Cradh, DASpell.BeagCradh };
            string staff = "";

            while(HKRunning[runInfo]) {
                if(GetDAStatNumber(DAStat.CurMP, runInfo) > 120) {
                    if(MainF.checkBox_suain.Checked && IsDASpellIconOn(DASpell.Sleep, runInfo)) {
                        if(MainF.checkBox_instantaosuain.Checked) {
                            staff = GetDAEquipment(DAEquipment.Weapon, runInfo);
                            if(staff.Contains("Cross") || staff == "Holy Diana" || staff == "Veltain Staff" || staff == "Magus Diana" || staff == "Master Divine Staff") {
                                UseDAAttack(suain[0], DAPane.d, true, runInfo, DAMacOps.M_TGTSELF | DAMacOps.DATK_NOCHKSPELLS | DAMacOps.DATK_CLKMOUSEFIRST);
                                Thread.Sleep(350);
                            }
                        } else {
                            UseDAAttack(suain[0], DAPane.d, true, runInfo, DAMacOps.M_TGTSELF | DAMacOps.DATK_NOCHKSPELLS | DAMacOps.DATK_CLKMOUSEFIRST);
                            Thread.Sleep(1025);
                        }
                    } else if(MainF.checkBox_puin.Checked && IsDASpellIconOn(DASpell.Poison, runInfo)) {
                        if(MainF.checkBox_instantaopuin.Checked) {
                            staff = GetDAEquipment(DAEquipment.Weapon, runInfo);
                            if(staff.Contains("Cross") || staff == "Holy Diana" || staff == "Veltain Staff" || staff == "Magus Diana" || staff == "Master Divine Staff") {
                                UseDAAttack(puin[0], DAPane.d, true, runInfo, DAMacOps.M_TGTSELF | DAMacOps.DATK_CLKMOUSEFIRST);
                                Thread.Sleep(350);
                            }
                        } else {
                            UseDAAttack(puin[0], DAPane.d, true, runInfo, DAMacOps.M_TGTSELF | DAMacOps.DATK_CLKMOUSEFIRST);
                            Thread.Sleep(1025);
                        }
                    } else if(MainF.checkBox_puin.Checked && IsDASpellIconOn(DASpell.Disease, runInfo)) {
                        if(MainF.checkBox_instantaopuin.Checked) {
                            staff = GetDAEquipment(DAEquipment.Weapon, runInfo);
                            if(staff.Contains("Cross") || staff == "Holy Diana" || staff == "Veltain Staff" || staff == "Magus Diana" || staff == "Master Divine Staff") {
                                UseDAAttack(puin[0], DAPane.d, true, runInfo, DAMacOps.M_TGTSELF | DAMacOps.DATK_CLKMOUSEFIRST);
                                Thread.Sleep(350);
                            }
                        } else {
                            UseDAAttack(puin[0], DAPane.d, true, runInfo, DAMacOps.M_TGTSELF | DAMacOps.DATK_CLKMOUSEFIRST);
                            Thread.Sleep(1025);
                        }
                    } else if(MainF.checkBox_puin.Checked && IsDASpellIconOn(DASpell.Decay, runInfo)) {
                        if(MainF.checkBox_instantaopuin.Checked) {
                            staff = GetDAEquipment(DAEquipment.Weapon, runInfo);
                            if(staff.Contains("Cross") || staff == "Holy Diana" || staff == "Veltain Staff" || staff == "Magus Diana" || staff == "Master Divine Staff") {
                                UseDAAttack(puin[0], DAPane.d, true, runInfo, DAMacOps.M_TGTSELF | DAMacOps.DATK_CLKMOUSEFIRST);
                                Thread.Sleep(350);
                            }
                        } else {
                            UseDAAttack(puin[0], DAPane.d, true, runInfo, DAMacOps.M_TGTSELF | DAMacOps.DATK_CLKMOUSEFIRST);
                            Thread.Sleep(1025);
                        }
                    } else if(MainF.checkBox_dall.Checked && IsDASpellIconOn(DASpell.Blind, runInfo)) {
                        if(MainF.checkBox_instantaodall.Checked) {
                            staff = GetDAEquipment(DAEquipment.Weapon, runInfo);
                            if(staff.Contains("Cross") || staff == "Holy Diana" || staff == "Veltain Staff" || staff == "Magus Diana" || staff == "Master Divine Staff") {
                                UseDAAttack(dall[0], DAPane.d, true, runInfo, DAMacOps.M_TGTSELF | DAMacOps.DATK_CLKMOUSEFIRST);
                                Thread.Sleep(350);
                            }
                        } else {
                            UseDAAttack(dall[0], DAPane.d, true, runInfo, DAMacOps.M_TGTSELF | DAMacOps.DATK_CLKMOUSEFIRST);
                            Thread.Sleep(1025);
                        }
                    } else if(MainF.checkBox_ard.Checked && IsDASpellIconOn(DASpell.ArdCradh, runInfo)) {
                        if(MainF.checkBox_instantaoard.Checked) {
                            staff = GetDAEquipment(DAEquipment.Weapon, runInfo);
                            if(staff.Contains("Cross") || staff == "Holy Diana" || staff == "Veltain Staff" || staff == "Magus Diana" || staff == "Master Divine Staff") {
                                UseDAAttack(ard[0], DAPane.d, true, runInfo, DAMacOps.M_TGTSELF | DAMacOps.DATK_CLKMOUSEFIRST);
                                Thread.Sleep(350);
                            }
                        } else {
                            UseDAAttack(ard[0], DAPane.d, true, runInfo, DAMacOps.M_TGTSELF | DAMacOps.DATK_CLKMOUSEFIRST);
                            Thread.Sleep(1025);
                        }
                    } else if(MainF.checkBox_mor.Checked && IsDASpellIconOn(DASpell.MorCradh, runInfo)) {
                        if(MainF.checkBox_instantaomor.Checked) {
                            staff = GetDAEquipment(DAEquipment.Weapon, runInfo);
                            if(staff.Contains("Cross") || staff == "Holy Diana" || staff == "Veltain Staff" || staff == "Magus Diana" || staff == "Master Divine Staff") {
                                UseDAAttack(mor[0], DAPane.d, true, runInfo, DAMacOps.M_TGTSELF | DAMacOps.DATK_CLKMOUSEFIRST);
                                Thread.Sleep(350);
                            }
                        } else {
                            UseDAAttack(mor[0], DAPane.d, true, runInfo, DAMacOps.M_TGTSELF | DAMacOps.DATK_CLKMOUSEFIRST);
                            Thread.Sleep(1025);
                        }
                    } else if(MainF.checkBox_cradh.Checked && IsDASpellIconOn(DASpell.Cradh, runInfo)) {
                        if(MainF.checkBox_instantaocradh.Checked) {
                            staff = GetDAEquipment(DAEquipment.Weapon, runInfo);
                            if(staff.Contains("Cross") || staff == "Holy Diana" || staff == "Veltain Staff" || staff == "Magus Diana" || staff == "Master Divine Staff") {
                                UseDAAttack(cradh[0], DAPane.d, true, runInfo, DAMacOps.M_TGTSELF | DAMacOps.DATK_CLKMOUSEFIRST);
                                Thread.Sleep(350);
                            }
                        } else {
                            UseDAAttack(cradh[0], DAPane.d, true, runInfo, DAMacOps.M_TGTSELF | DAMacOps.DATK_CLKMOUSEFIRST);
                            Thread.Sleep(1025);
                        }
                    } else if(MainF.checkBox_beag.Checked && IsDASpellIconOn(DASpell.BeagCradh, runInfo)) {
                        if(MainF.checkBox_instantaobeag.Checked) {
                            staff = GetDAEquipment(DAEquipment.Weapon, runInfo);
                            if(staff.Contains("Cross") || staff == "Holy Diana" || staff == "Veltain Staff" || staff == "Magus Diana" || staff == "Master Divine Staff") {
                                UseDAAttack(beag[0], DAPane.d, true, runInfo, DAMacOps.M_TGTSELF | DAMacOps.DATK_CLKMOUSEFIRST);
                                Thread.Sleep(350);
                            }
                        } else {
                            UseDAAttack(beag[0], DAPane.d, true, runInfo, DAMacOps.M_TGTSELF | DAMacOps.DATK_CLKMOUSEFIRST);
                            Thread.Sleep(1025);
                        }
                    } else if(MainF.checkBox_beagcradh.Checked && GetDAStatNumber(DAStat.CurMP, runInfo) > 500 && !IsDASpellIconOn(spellsToCheck, runInfo)) {
                        if(MainF.checkBox_instantbeagcradh.Checked) {
                            staff = GetDAEquipment(DAEquipment.Weapon, runInfo);
                            if(staff.Contains("Cross") || staff == "Holy Diana" || staff == "Veltain Staff" || staff == "Magus Ares" || staff == "Master Gnarl" || staff == "Master Divine Staff") {
                                UseDAAttack(new byte[] { beagcradh[0], beagcradh[0], beagcradh[0] }, new DAPane[] { DAPane.d, DAPane.d, DAPane.d }, new bool[] { true, true, true }, runInfo, DAMacOps.M_TGTSELF | DAMacOps.DATK_CLKMOUSEFIRST);
                                Thread.Sleep(200);
                            }
                        } else {
                            UseDAAttack(beagcradh[0], DAPane.d, true, runInfo, DAMacOps.M_TGTSELF | DAMacOps.DATK_CLKMOUSEFIRST);
                            Thread.Sleep(1025);
                        }
                    }
                }
                Thread.Sleep(50);
            }
            Tip.Dispose();
        }
    }
}